Index: /palm/trunk/SOURCE/turbulence_closure_mod.f90
===================================================================
--- /palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 4509)
+++ /palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 4510)
@@ -2551,30 +2532,34 @@
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Prognostic equation for subgrid-scale TKE and TKE dissipation rate.
-!> Cache-optimized version
-!------------------------------------------------------------------------------!
+!> Prognostic equation for subgrid-scale TKE and TKE dissipation rate. Cache-optimized version
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE tcm_prognostic_equations_ij( i, j, i_omp, tn )
 
-    USE arrays_3d,                                                             &
-        ONLY:  diss_l_diss, diss_l_e, diss_s_diss, diss_s_e, flux_l_diss,      &
-               flux_l_e, flux_s_diss, flux_s_e
-
-    USE control_parameters,                                                    &
+    USE arrays_3d,                                                                                 &
+        ONLY:  diss_l_diss,                                                                        &
+               diss_l_e,                                                                           &
+               diss_s_diss,                                                                        &
+               diss_s_e,                                                                           &
+               flux_l_diss,                                                                        &
+               flux_l_e,                                                                           &
+               flux_s_diss,                                                                        &
+               flux_s_e
+
+    USE control_parameters,                                                                        &
         ONLY:  tsc
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i       !< loop index x direction
-    INTEGER(iwp) ::  i_omp   !< first loop index of i-loop in prognostic_equations
-    INTEGER(iwp) ::  j       !< loop index y direction
-    INTEGER(iwp) ::  k       !< loop index z direction
-    INTEGER(iwp) ::  tn      !< task number of openmp task
-
-!
-!-- If required, compute prognostic equation for turbulent kinetic
-!-- energy (TKE)
+    INTEGER(iwp) ::  i      !< loop index x direction
+    INTEGER(iwp) ::  i_omp  !< first loop index of i-loop in prognostic_equations
+    INTEGER(iwp) ::  j      !< loop index y direction
+    INTEGER(iwp) ::  k      !< loop index z direction
+    INTEGER(iwp) ::  tn     !< task number of openmp task
+
+!
+!-- If required, compute prognostic equation for turbulent kinetic energy (TKE)
     IF ( .NOT. constant_diffusion )  THEN
 
@@ -2582,13 +2567,11 @@
 !--    Tendency-terms for TKE
        tend(:,j,i) = 0.0_wp
-       IF ( timestep_scheme(1:5) == 'runge'  &
-           .AND.  .NOT. use_upstream_for_tke )  THEN
+       IF ( timestep_scheme(1:5) == 'runge'  .AND.  .NOT. use_upstream_for_tke )  THEN
            IF ( ws_scheme_sca )  THEN
-               CALL advec_s_ws( advc_flags_s,                                  &
-                                i, j, e, 'e', flux_s_e, diss_s_e,              &
-                                flux_l_e, diss_l_e , i_omp, tn,                &
-                                bc_dirichlet_l  .OR.  bc_radiation_l,          &
-                                bc_dirichlet_n  .OR.  bc_radiation_n,          &
-                                bc_dirichlet_r  .OR.  bc_radiation_r,          &
+               CALL advec_s_ws( advc_flags_s, i, j, e, 'e', flux_s_e, diss_s_e, flux_l_e,          &
+                                diss_l_e , i_omp, tn,                                              &
+                                bc_dirichlet_l  .OR.  bc_radiation_l,                              &
+                                bc_dirichlet_n  .OR.  bc_radiation_n,                              &
+                                bc_dirichlet_r  .OR.  bc_radiation_r,                              &
                                 bc_dirichlet_s  .OR.  bc_radiation_s )
            ELSE
@@ -2619,14 +2602,9 @@
 !
 !--    Prognostic equation for TKE.
-!--    Eliminate negative TKE values, which can occur due to numerical
-!--    reasons in the course of the integration. In such cases the old
-!--    TKE value is reduced by 90%.
+!--    Eliminate negative TKE values, which can occur due to numerical reasons in the course of the
+!--    integration. In such cases the old TKE value is reduced by 90%.
        DO  k = nzb+1, nzt
-          e_p(k,j,i) = e(k,j,i) + ( dt_3d * ( tsc(2) * tend(k,j,i) +           &
-                                              tsc(3) * te_m(k,j,i) )           &
-                                  )                                            &
-                                 * MERGE( 1.0_wp, 0.0_wp,                      &
-                                    BTEST( wall_flags_total_0(k,j,i), 0 )      &
-                                        )
+          e_p(k,j,i) = e(k,j,i) + ( dt_3d * ( tsc(2) * tend(k,j,i) + tsc(3) * te_m(k,j,i) ) )      &
+                       * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
           IF ( e_p(k,j,i) <= 0.0_wp )  e_p(k,j,i) = 0.1_wp * e(k,j,i)
        ENDDO
@@ -2639,9 +2617,7 @@
                 te_m(k,j,i) = tend(k,j,i)
              ENDDO
-          ELSEIF ( intermediate_timestep_count < &
-                   intermediate_timestep_count_max )  THEN
+          ELSEIF ( intermediate_timestep_count < intermediate_timestep_count_max )  THEN
              DO  k = nzb+1, nzt
-                te_m(k,j,i) =   -9.5625_wp * tend(k,j,i) +                     &
-                                 5.3125_wp * te_m(k,j,i)
+                te_m(k,j,i) = -9.5625_wp * tend(k,j,i) + 5.3125_wp * te_m(k,j,i)
              ENDDO
           ENDIF
@@ -2656,13 +2632,11 @@
 !--    Tendency-terms for dissipation
        tend(:,j,i) = 0.0_wp
-       IF ( timestep_scheme(1:5) == 'runge'  &
-           .AND.  .NOT. use_upstream_for_tke )  THEN
+       IF ( timestep_scheme(1:5) == 'runge'  .AND.  .NOT. use_upstream_for_tke )  THEN
            IF ( ws_scheme_sca )  THEN
-               CALL advec_s_ws( advc_flags_s,                                  &
-                                i, j, diss, 'diss', flux_s_diss, diss_s_diss,  &
-                                flux_l_diss, diss_l_diss, i_omp, tn,           &
-                                bc_dirichlet_l  .OR.  bc_radiation_l,          &
-                                bc_dirichlet_n  .OR.  bc_radiation_n,          &
-                                bc_dirichlet_r  .OR.  bc_radiation_r,          &
+               CALL advec_s_ws( advc_flags_s, i, j, diss, 'diss', flux_s_diss, diss_s_diss,        &
+                                flux_l_diss, diss_l_diss, i_omp, tn,                               &
+                                bc_dirichlet_l  .OR.  bc_radiation_l,                              &
+                                bc_dirichlet_n  .OR.  bc_radiation_n,                              &
+                                bc_dirichlet_r  .OR.  bc_radiation_r,                              &
                                 bc_dirichlet_s  .OR.  bc_radiation_s )
            ELSE
@@ -2686,14 +2660,10 @@
 !
 !--    Prognostic equation for TKE dissipation
-!--    Eliminate negative dissipation values, which can occur due to
-!--    numerical reasons in the course of the integration. In such cases
-!--    the old dissipation value is reduced by 90%.
+!--    Eliminate negative dissipation values, which can occur due to numerical reasons in the course
+!--    of the integration. In such cases the old dissipation value is reduced by 90%.
        DO  k = nzb+1, nzt
-          diss_p(k,j,i) = diss(k,j,i) + ( dt_3d * ( tsc(2) * tend(k,j,i) +     &
-                                                    tsc(3) * tdiss_m(k,j,i) )  &
-                                        )                                      &
-                                        * MERGE( 1.0_wp, 0.0_wp,               &
-                                          BTEST( wall_flags_total_0(k,j,i), 0 )&
-                                               )
+          diss_p(k,j,i) = diss(k,j,i) + ( dt_3d * ( tsc(2) * tend(k,j,i) + tsc(3)                  &
+                          * tdiss_m(k,j,i) ) )                                                     &
+                          * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
        ENDDO
 
@@ -2705,54 +2675,66 @@
                 tdiss_m(k,j,i) = tend(k,j,i)
              ENDDO
-          ELSEIF ( intermediate_timestep_count < &
-                   intermediate_timestep_count_max )  THEN
+          ELSEIF ( intermediate_timestep_count < intermediate_timestep_count_max )  THEN
              DO  k = nzb+1, nzt
-                tdiss_m(k,j,i) =   -9.5625_wp * tend(k,j,i) +                  &
-                                    5.3125_wp * tdiss_m(k,j,i)
+                tdiss_m(k,j,i) = -9.5625_wp * tend(k,j,i) + 5.3125_wp * tdiss_m(k,j,i)
              ENDDO
           ENDIF
        ENDIF
 
-    ENDIF   ! dissipation equation
+    ENDIF   ! Dissipation equation
 
  END SUBROUTINE tcm_prognostic_equations_ij
 
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Production terms (shear + buoyancy) of the TKE.
 !> Vector-optimized version
-!> @warning The case with constant_flux_layer = F and use_surface_fluxes = T is
-!>          not considered well!
-!------------------------------------------------------------------------------!
+!> @warning The case with constant_flux_layer = F and use_surface_fluxes = T is not considered well!
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE production_e( diss_production )
 
-    USE arrays_3d,                                                             &
-        ONLY:  ddzw, dd2zu, drho_air_zw, q, ql, d_exner, exner
-
-    USE control_parameters,                                                    &
-        ONLY:  cloud_droplets, constant_flux_layer, neutral,                   &
-               rho_reference, use_single_reference_value, use_surface_fluxes,  &
+    USE arrays_3d,                                                                                 &
+        ONLY:  ddzw,                                                                               &
+               dd2zu,                                                                              &
+               d_exner,                                                                            &
+               drho_air_zw,                                                                        &
+               exner,                                                                              &
+               q,                                                                                  &
+               ql
+
+
+
+    USE control_parameters,                                                                        &
+        ONLY:  cloud_droplets,                                                                     &
+               constant_flux_layer,                                                                &
+               neutral,                                                                            &
+               rho_reference,                                                                      &
+               use_single_reference_value,                                                         &
+               use_surface_fluxes,                                                                 &
                use_top_fluxes
 
-    USE grid_variables,                                                        &
-        ONLY:  ddx, dx, ddy, dy
-
-    USE bulk_cloud_model_mod,                                                  &
+    USE grid_variables,                                                                            &
+        ONLY:  ddx,                                                                                &
+               dx,                                                                                 &
+               ddy,                                                                                &
+               dy
+
+    USE bulk_cloud_model_mod,                                                                      &
         ONLY:  bulk_cloud_model
 
     IMPLICIT NONE
 
-    LOGICAL :: diss_production
-
-    INTEGER(iwp) ::  i       !< running index x-direction
-    INTEGER(iwp) ::  j       !< running index y-direction
-    INTEGER(iwp) ::  k       !< running index z-direction
-    INTEGER(iwp) ::  l       !< running index for different surface type orientation
-    INTEGER(iwp) ::  m       !< running index surface elements
-    INTEGER(iwp) ::  surf_e  !< end index of surface elements at given i-j position
-    INTEGER(iwp) ::  surf_s  !< start index of surface elements at given i-j position
-    INTEGER(iwp) ::  flag_nr !< number of masking flag
+    LOGICAL ::  diss_production  !<
+
+    INTEGER(iwp) ::  flag_nr  !< number of masking flag
+    INTEGER(iwp) ::  i        !< running index x-direction
+    INTEGER(iwp) ::  j        !< running index y-direction
+    INTEGER(iwp) ::  k        !< running index z-direction
+    INTEGER(iwp) ::  l        !< running index for different surface type orientation
+    INTEGER(iwp) ::  m        !< running index surface elements
+    INTEGER(iwp) ::  surf_e   !< end index of surface elements at given i-j position
+    INTEGER(iwp) ::  surf_s   !< start index of surface elements at given i-j position
 
     REAL(wp)     ::  def         !< ( du_i/dx_j + du_j/dx_i ) * du_i/dx_j
@@ -2761,7 +2743,7 @@
     REAL(wp)     ::  k2          !< temporary factor
     REAL(wp)     ::  km_neutral  !< diffusion coefficient assuming neutral conditions - used to compute shear production at surfaces
+    REAL(wp)     ::  sign_dir    !< sign of wall-tke flux, depending on wall orientation
     REAL(wp)     ::  theta       !< virtual potential temperature
     REAL(wp)     ::  temp        !< theta * Exner-function
-    REAL(wp)     ::  sign_dir    !< sign of wall-tke flux, depending on wall orientation
     REAL(wp)     ::  usvs        !< momentum flux u"v"
     REAL(wp)     ::  vsus        !< momentum flux v"u"
@@ -2769,13 +2751,13 @@
     REAL(wp)     ::  wsvs        !< momentum flux w"v"
 
-    REAL(wp), DIMENSION(nzb+1:nzt) ::  dudx  !< Gradient of u-component in x-direction
-    REAL(wp), DIMENSION(nzb+1:nzt) ::  dudy  !< Gradient of u-component in y-direction
-    REAL(wp), DIMENSION(nzb+1:nzt) ::  dudz  !< Gradient of u-component in z-direction
-    REAL(wp), DIMENSION(nzb+1:nzt) ::  dvdx  !< Gradient of v-component in x-direction
-    REAL(wp), DIMENSION(nzb+1:nzt) ::  dvdy  !< Gradient of v-component in y-direction
-    REAL(wp), DIMENSION(nzb+1:nzt) ::  dvdz  !< Gradient of v-component in z-direction
-    REAL(wp), DIMENSION(nzb+1:nzt) ::  dwdx  !< Gradient of w-component in x-direction
-    REAL(wp), DIMENSION(nzb+1:nzt) ::  dwdy  !< Gradient of w-component in y-direction
-    REAL(wp), DIMENSION(nzb+1:nzt) ::  dwdz  !< Gradient of w-component in z-direction
+    REAL(wp), DIMENSION(nzb+1:nzt) ::  dudx      !< Gradient of u-component in x-direction
+    REAL(wp), DIMENSION(nzb+1:nzt) ::  dudy      !< Gradient of u-component in y-direction
+    REAL(wp), DIMENSION(nzb+1:nzt) ::  dudz      !< Gradient of u-component in z-direction
+    REAL(wp), DIMENSION(nzb+1:nzt) ::  dvdx      !< Gradient of v-component in x-direction
+    REAL(wp), DIMENSION(nzb+1:nzt) ::  dvdy      !< Gradient of v-component in y-direction
+    REAL(wp), DIMENSION(nzb+1:nzt) ::  dvdz      !< Gradient of v-component in z-direction
+    REAL(wp), DIMENSION(nzb+1:nzt) ::  dwdx      !< Gradient of w-component in x-direction
+    REAL(wp), DIMENSION(nzb+1:nzt) ::  dwdy      !< Gradient of w-component in y-direction
+    REAL(wp), DIMENSION(nzb+1:nzt) ::  dwdz      !< Gradient of w-component in z-direction
     REAL(wp), DIMENSION(nzb+1:nzt) ::  tmp_flux  !< temporary flux-array in z-direction
 
@@ -2783,7 +2765,6 @@
 
 !
-!-- Calculate TKE production by shear. Calculate gradients at all grid
-!-- points first, gradients at surface-bounded grid points will be
-!-- overwritten further below.
+!-- Calculate TKE production by shear. Calculate gradients at all grid points first, gradients at
+!-- surface-bounded grid points will be overwritten further below.
     !$ACC PARALLEL LOOP COLLAPSE(2) PRIVATE(i, j, l) &
     !$ACC PRIVATE(surf_s, surf_e) &
@@ -2800,19 +2781,13 @@
 
              dudx(k) =           ( u(k,j,i+1) - u(k,j,i)     ) * ddx
-             dudy(k) = 0.25_wp * ( u(k,j+1,i) + u(k,j+1,i+1) -                 &
-                                   u(k,j-1,i) - u(k,j-1,i+1) ) * ddy
-             dudz(k) = 0.5_wp  * ( u(k+1,j,i) + u(k+1,j,i+1) -                 &
-                                   u(k-1,j,i) - u(k-1,j,i+1) ) * dd2zu(k)
-
-             dvdx(k) = 0.25_wp * ( v(k,j,i+1) + v(k,j+1,i+1) -                 &
-                                   v(k,j,i-1) - v(k,j+1,i-1) ) * ddx
+             dudy(k) = 0.25_wp * ( u(k,j+1,i) + u(k,j+1,i+1) - u(k,j-1,i) - u(k,j-1,i+1) ) * ddy
+             dudz(k) = 0.5_wp  * ( u(k+1,j,i) + u(k+1,j,i+1) - u(k-1,j,i) - u(k-1,j,i+1) ) * dd2zu(k)
+
+             dvdx(k) = 0.25_wp * ( v(k,j,i+1) + v(k,j+1,i+1) - v(k,j,i-1) - v(k,j+1,i-1) ) * ddx
              dvdy(k) =           ( v(k,j+1,i) - v(k,j,i)     ) * ddy
-             dvdz(k) = 0.5_wp  * ( v(k+1,j,i) + v(k+1,j+1,i) -                 &
-                                     v(k-1,j,i) - v(k-1,j+1,i) ) * dd2zu(k)
-
-             dwdx(k) = 0.25_wp * ( w(k,j,i+1) + w(k-1,j,i+1) -                 &
-                                   w(k,j,i-1) - w(k-1,j,i-1) ) * ddx
-             dwdy(k) = 0.25_wp * ( w(k,j+1,i) + w(k-1,j+1,i) -                 &
-                                   w(k,j-1,i) - w(k-1,j-1,i) ) * ddy
+             dvdz(k) = 0.5_wp  * ( v(k+1,j,i) + v(k+1,j+1,i) - v(k-1,j,i) - v(k-1,j+1,i) ) * dd2zu(k)
+
+             dwdx(k) = 0.25_wp * ( w(k,j,i+1) + w(k-1,j,i+1) - w(k,j,i-1) - w(k-1,j,i-1) ) * ddx
+             dwdy(k) = 0.25_wp * ( w(k,j+1,i) + w(k-1,j+1,i) - w(k,j-1,i) - w(k-1,j-1,i) ) * ddy
              dwdz(k) =           ( w(k,j,i)   - w(k-1,j,i)   ) * ddzw(k)
 
@@ -2832,7 +2807,6 @@
 !--          'bottom and wall: use u_0,v_0 and wall functions'
 !
-!--          Compute gradients at north- and south-facing surfaces.
-!--          First, for default surfaces, then for urban surfaces.
-!--          Note, so far no natural vertical surfaces implemented
+!--          Compute gradients at north- and south-facing surfaces. First, for default surfaces,
+!--          then for urban surfaces. Note, so far no natural vertical surfaces implemented
              DO  l = 0, 1
                 surf_s = surf_def_v(l)%start_index(j,i)
@@ -2844,10 +2818,8 @@
                    wsvs        = surf_def_v(l)%mom_flux_tke(1,m)
 
-                   km_neutral = kappa * ( usvs**2 + wsvs**2 )**0.25_wp         &
-                                      * 0.5_wp * dy
+                   km_neutral = kappa * ( usvs**2 + wsvs**2 )**0.25_wp * 0.5_wp * dy
 !
 !--                -1.0 for right-facing wall, 1.0 for left-facing wall
-                   sign_dir = MERGE( 1.0_wp, -1.0_wp,                          &
-                              BTEST( wall_flags_total_0(k,j-1,i), flag_nr ) )
+                   sign_dir = MERGE( 1.0_wp, -1.0_wp, BTEST( wall_flags_total_0(k,j-1,i), flag_nr ) )
                    dudy(k) = sign_dir * usvs / ( km_neutral + 1E-10_wp )
                    dwdy(k) = sign_dir * wsvs / ( km_neutral + 1E-10_wp )
@@ -2863,10 +2835,8 @@
                    wsvs        = surf_lsm_v(l)%mom_flux_tke(1,m)
 
-                   km_neutral = kappa * ( usvs**2 + wsvs**2 )**0.25_wp         &
-                                      * 0.5_wp * dy
+                   km_neutral = kappa * ( usvs**2 + wsvs**2 )**0.25_wp * 0.5_wp * dy
 !
 !--                -1.0 for right-facing wall, 1.0 for left-facing wall
-                   sign_dir = MERGE( 1.0_wp, -1.0_wp,                          &
-                              BTEST( wall_flags_total_0(k,j-1,i), flag_nr ) )
+                   sign_dir = MERGE( 1.0_wp, -1.0_wp, BTEST( wall_flags_total_0(k,j-1,i), flag_nr ) )
                    dudy(k) = sign_dir * usvs / ( km_neutral + 1E-10_wp )
                    dwdy(k) = sign_dir * wsvs / ( km_neutral + 1E-10_wp )
@@ -2882,10 +2852,8 @@
                    wsvs        = surf_usm_v(l)%mom_flux_tke(1,m)
 
-                   km_neutral = kappa * ( usvs**2 + wsvs**2 )**0.25_wp         &
-                                      * 0.5_wp * dy
+                   km_neutral = kappa * ( usvs**2 + wsvs**2 )**0.25_wp * 0.5_wp * dy
 !
 !--                -1.0 for right-facing wall, 1.0 for left-facing wall
-                   sign_dir = MERGE( 1.0_wp, -1.0_wp,                          &
-                              BTEST( wall_flags_total_0(k,j-1,i), flag_nr ) )
+                   sign_dir = MERGE( 1.0_wp, -1.0_wp, BTEST( wall_flags_total_0(k,j-1,i), flag_nr ) )
                    dudy(k) = sign_dir * usvs / ( km_neutral + 1E-10_wp )
                    dwdy(k) = sign_dir * wsvs / ( km_neutral + 1E-10_wp )
@@ -2903,10 +2871,8 @@
                    wsus  = surf_def_v(l)%mom_flux_tke(1,m)
 
-                   km_neutral = kappa * ( vsus**2 + wsus**2 )**0.25_wp         &
-                                      * 0.5_wp * dx
+                   km_neutral = kappa * ( vsus**2 + wsus**2 )**0.25_wp * 0.5_wp * dx
 !
 !--                -1.0 for right-facing wall, 1.0 for left-facing wall
-                   sign_dir = MERGE( 1.0_wp, -1.0_wp,                          &
-                              BTEST( wall_flags_total_0(k,j,i-1), flag_nr ) )
+                   sign_dir = MERGE( 1.0_wp, -1.0_wp, BTEST( wall_flags_total_0(k,j,i-1), flag_nr ) )
                    dvdx(k) = sign_dir * vsus / ( km_neutral + 1E-10_wp )
                    dwdx(k) = sign_dir * wsus / ( km_neutral + 1E-10_wp )
@@ -2922,10 +2888,8 @@
                    wsus  = surf_lsm_v(l)%mom_flux_tke(1,m)
 
-                   km_neutral = kappa * ( vsus**2 + wsus**2 )**0.25_wp         &
-                                      * 0.5_wp * dx
+                   km_neutral = kappa * ( vsus**2 + wsus**2 )**0.25_wp * 0.5_wp * dx
 !
 !--                -1.0 for right-facing wall, 1.0 for left-facing wall
-                   sign_dir = MERGE( 1.0_wp, -1.0_wp,                          &
-                              BTEST( wall_flags_total_0(k,j,i-1), flag_nr ) )
+                   sign_dir = MERGE( 1.0_wp, -1.0_wp, BTEST( wall_flags_total_0(k,j,i-1), flag_nr ) )
                    dvdx(k) = sign_dir * vsus / ( km_neutral + 1E-10_wp )
                    dwdx(k) = sign_dir * wsus / ( km_neutral + 1E-10_wp )
@@ -2941,10 +2905,8 @@
                    wsus  = surf_usm_v(l)%mom_flux_tke(1,m)
 
-                   km_neutral = kappa * ( vsus**2 + wsus**2 )**0.25_wp         &
-                                      * 0.5_wp * dx
+                   km_neutral = kappa * ( vsus**2 + wsus**2 )**0.25_wp * 0.5_wp * dx
 !
 !--                -1.0 for right-facing wall, 1.0 for left-facing wall
-                   sign_dir = MERGE( 1.0_wp, -1.0_wp,                          &
-                              BTEST( wall_flags_total_0(k,j,i-1), flag_nr ) )
+                   sign_dir = MERGE( 1.0_wp, -1.0_wp, BTEST( wall_flags_total_0(k,j,i-1), flag_nr ) )
                    dvdx(k) = sign_dir * vsus / ( km_neutral + 1E-10_wp )
                    dwdx(k) = sign_dir * wsus / ( km_neutral + 1E-10_wp )
@@ -2959,9 +2921,8 @@
                 k = surf_def_h(0)%k(m)
 !
-!--             Please note, actually, an interpolation of u_0 and v_0
-!--             onto the grid center would be required. However, this
-!--             would require several data transfers between 2D-grid and
-!--             wall type. The effect of this missing interpolation is
-!--             negligible. (See also production_e_init).
+!--             Please note, actually, an interpolation of u_0 and v_0 onto the grid center would be
+!--             required. However, this would require several data transfers between 2D-grid and
+!--             wall type. The effect of this missing interpolation is negligible.
+!--            (See also production_e_init).
                 dudz(k) = ( u(k+1,j,i) - surf_def_h(0)%u_0(m) ) * dd2zu(k)
                 dvdz(k) = ( v(k+1,j,i) - surf_def_h(0)%v_0(m) ) * dd2zu(k)
@@ -2993,6 +2954,5 @@
              ENDDO
 !
-!--          Compute gradients at downward-facing walls, only for
-!--          non-natural default surfaces
+!--          Compute gradients at downward-facing walls, only for non-natural default surfaces
              surf_s = surf_def_h(1)%start_index(j,i)
              surf_e = surf_def_h(1)%end_index(j,i)
@@ -3013,9 +2973,7 @@
           DO  k = nzb+1, nzt
 
-             def = 2.0_wp * ( dudx(k)**2 + dvdy(k)**2 + dwdz(k)**2 ) +         &
-                              dudy(k)**2 + dvdx(k)**2 + dwdx(k)**2 +           &
-                              dwdy(k)**2 + dudz(k)**2 + dvdz(k)**2 +           &
-                   2.0_wp * ( dvdx(k)*dudy(k) + dwdx(k)*dudz(k) +              &
-                              dwdy(k)*dvdz(k) )
+             def = 2.0_wp * ( dudx(k)**2 + dvdy(k)**2 + dwdz(k)**2 ) + dudy(k)**2 + dvdx(k)**2 +   &
+                   dwdx(k)**2 + dwdy(k)**2 + dudz(k)**2 + dvdz(k)**2 +                             &
+                   2.0_wp * ( dvdx(k)*dudy(k) + dwdx(k)*dudz(k) + dwdy(k)*dvdz(k) )
 
              IF ( def < 0.0_wp )  def = 0.0_wp
@@ -3031,6 +2989,6 @@
 
 !--             RANS mode: Compute tendency for dissipation-rate-production from shear
-                tend(k,j,i) = tend(k,j,i) + km(k,j,i) * def * flag *           &
-                              diss(k,j,i)/( e(k,j,i) + 1.0E-20_wp ) * c_1
+                tend(k,j,i) = tend(k,j,i) + km(k,j,i) * def * flag * diss(k,j,i) /                 &
+                              ( e(k,j,i) + 1.0E-20_wp ) * c_1
 
              ENDIF
@@ -3050,6 +3008,6 @@
           IF ( ocean_mode )  THEN
 !
-!--          So far in the ocean no special treatment of density flux
-!--          in the bottom and top surface layer
+!--          So far in the ocean no special treatment of density flux in the bottom and top surface
+!--          layer
              DO  i = nxl, nxr
                 DO  j = nys, nyn
@@ -3059,6 +3017,5 @@
                    ENDDO
 !
-!--                Treatment of near-surface grid points, at up- and down-
-!--                ward facing surfaces
+!--                Treatment of near-surface grid points, at up- and down-ward facing surfaces
                    IF ( use_surface_fluxes )  THEN
                       DO  l = 0, 1
@@ -3085,7 +3042,7 @@
 !--                   Compute tendency for TKE-production from shear
                       DO  k = nzb+1, nzt
-                         flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_total_0(k,j,i),0) )
-                         tend(k,j,i) = tend(k,j,i) + flag * tmp_flux(k) * ( g / &
-                                       MERGE( rho_reference, prho(k,j,i),       &
+                         flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
+                         tend(k,j,i) = tend(k,j,i) + flag * tmp_flux(k) * ( g /                    &
+                                       MERGE( rho_reference, prho(k,j,i),                          &
                                               use_single_reference_value ) )
                       ENDDO
@@ -3095,10 +3052,9 @@
 !--                   RANS mode: Compute tendency for dissipation-rate-production from shear
                       DO  k = nzb+1, nzt
-                         flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_total_0(k,j,i),0) )
-                         tend(k,j,i) = tend(k,j,i) + flag * tmp_flux(k) * ( g / &
-                                       MERGE( rho_reference, prho(k,j,i),       &
-                                              use_single_reference_value ) ) *  &
-                                       diss(k,j,i)/( e(k,j,i) + 1.0E-20_wp ) *  &
-                                       c_3
+                         flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
+                         tend(k,j,i) = tend(k,j,i) + flag * tmp_flux(k) * ( g /                    &
+                                       MERGE( rho_reference, prho(k,j,i),                          &
+                                              use_single_reference_value ) ) *                     &
+                                       diss(k,j,i)/( e(k,j,i) + 1.0E-20_wp ) *  c_3
                       ENDDO
 
@@ -3173,7 +3129,7 @@
                      !$ACC LOOP PRIVATE(k, flag)
                       DO  k = nzb+1, nzt
-                         flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_total_0(k,j,i),0) )
-                         tend(k,j,i) = tend(k,j,i) + flag * tmp_flux(k) * ( g / &
-                                       MERGE( pt_reference, pt(k,j,i),          &
+                         flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
+                         tend(k,j,i) = tend(k,j,i) + flag * tmp_flux(k) * ( g /                    &
+                                       MERGE( pt_reference, pt(k,j,i),                             &
                                               use_single_reference_value ) )
                       ENDDO
@@ -3183,10 +3139,9 @@
 !--                   RANS mode: Compute tendency for dissipation-rate-production from shear
                       DO  k = nzb+1, nzt
-                         flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_total_0(k,j,i),0) )
-                         tend(k,j,i) = tend(k,j,i) + flag * tmp_flux(k) * ( g / &
-                                       MERGE( pt_reference, pt(k,j,i),          &
-                                              use_single_reference_value ) ) *  &
-                                       diss(k,j,i)/( e(k,j,i) + 1.0E-20_wp ) *  &
-                                       c_3
+                         flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
+                         tend(k,j,i) = tend(k,j,i) + flag * tmp_flux(k) * ( g /                    &
+                                       MERGE( pt_reference, pt(k,j,i),                             &
+                                              use_single_reference_value ) ) *                     &
+                                       diss(k,j,i)/( e(k,j,i) + 1.0E-20_wp ) * c_3
                       ENDDO
 
@@ -3196,7 +3151,7 @@
              ENDDO
 
-          ENDIF ! from IF ( .NOT. ocean_mode )
-
-       ELSE ! or IF ( humidity )  THEN
+          ENDIF ! From IF ( .NOT. ocean_mode )
+
+       ELSE ! Or IF ( humidity )  THEN
 
           DO  i = nxl, nxr
